/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is ScrapBook CHM Creator.
 *
 * The Initial Developer of the Original Code is Gary Harris.
 * Portions created by the Initial Developer are Copyright (C) 2009
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *     Gomita <gomita@xuldev.org> (the author of Scrapbook)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

  // Get property strings.
  var strbundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
  this.strings = strbundle.createBundle("chrome://sbchm/locale/prefwindow.properties"); 

  // Get the path to the help compiler executable.
  function onBrowse()
  {
    // Init a file picker and display it.
    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    var browseFile = this.strings.GetStringFromName("browseFile");
    fp.init(window, browseFile, nsIFilePicker.modeOpen);
    fp.appendFilter("Windows Executable Files","*.exe; *.exe");  
    fp.appendFilters(nsIFilePicker.filterAll);

    var res = fp.show();
    if (res == nsIFilePicker.returnOK){
      var thefile = fp.file;
      // Update pref.
      document.getElementById("hhcpathpref").value = thefile.path;
    }
    
    return true;
  }

  // Get the path to the output directory.
  function onOutputBrowse()
  {
    // Init a file picker and display it.
    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    var browseFolder = this.strings.GetStringFromName("browseFolder");
    fp.init(window, browseFolder, nsIFilePicker.modeGetFolder);

    var res = fp.show();
    if (res == nsIFilePicker.returnOK){
      var thefile = fp.file;
      // Update pref.
      document.getElementById("outputpathpref").value = thefile.path;
    }
    
    return true;
  }
  
  // Get the path to the log file.
  function onLogBrowse()
  {
    // Init a file picker and display it.
    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    var browseFile = this.strings.GetStringFromName("browseFile");
    fp.init(window, browseFile, nsIFilePicker.modeOpen);
    fp.appendFilter("Log Files","*.log; *.log");
    fp.appendFilters(nsIFilePicker.filterText);
    fp.appendFilters(nsIFilePicker.filterAll);

    var res = fp.show();
    if (res == nsIFilePicker.returnOK){
      var thefile = fp.file;
      // Update pref.
      document.getElementById("logpathpref").value = thefile.path;
    }
    
    return true;
  }

  function onPaneLoad()
  {
    setControls(!document.getElementById("cbnavpane").checked);
    document.getElementById("cbnavtabadvanced").disabled = !document.getElementById("cbnavtabsearch").checked;
    var ml = document.getElementById("mlnavdefaulttab");
    var bToc = document.getElementById("cbnavtabtoc").checked;
    var bFavs = document.getElementById("cbnavtabfavs").checked;
    var bSrch = document.getElementById("cbnavtabsearch").checked;
    if(bToc){
      ml.insertItemAt(1, "Contents", 0);
    }
    if(bFavs){
      var arr = ml.getElementsByAttribute('label', "Contents");
      var iIndex = ml.getIndexOfItem(arr[0]);
      if(iIndex > -1){
        ml.insertItemAt(2, "Favorites", 3);
      }else{
        ml.appendItem("Favorites", 3);
      }
    }
    if(bSrch){
      ml.appendItem("Search", 2);
    }
    document.getElementById("cblocate").disabled = !bToc;
  }
  
  function onClickNavPane()
  {
    // checked returns the current state of the checkbox BEFORE the click changes it.
    setControls(document.getElementById("cbnavpane").checked);
  }

  // List Values:   Content   0
  //                Index     1
  //                Favorites 3
  //                Search    2
  //
  function onClickTOC()
  {
    // checked returns the current state of the checkbox BEFORE the click changes it.
    var bToc = document.getElementById("cbnavtabtoc").checked;
    var ml = document.getElementById("mlnavdefaulttab");
    // The "Locate" button doesn't make sense without a contents tab.
    var cblocate = document.getElementById("cblocate");
    // Neither does autosync.
    var cbautosync = document.getElementById("cbnavautosync");

    if(!bToc){
      // Checking.
      // Contents always appears first.
      ml.insertItemAt(1, "Contents", 0);
      cblocate.disabled = false;
      cbautosync.disabled = false;
    }else{
      // Unchecking.
      var arr = ml.getElementsByAttribute('label', "Contents");
      var iIndex = ml.getIndexOfItem(arr[0]);
      // Deselect from list, if necessary.
      if(iIndex == ml.selectedIndex){
        ml.selectedIndex = -1;
        document.getElementById("navdefaulttab").value = -1;
      }
      ml.removeItemAt(ml.getIndexOfItem(arr[0]));
      cblocate.disabled = true;
      cbautosync.disabled = true;
    }
  }

  function onClickIndex()
  {
    // checked returns the current state of the checkbox BEFORE the click changes it.
    var bIndx = document.getElementById("cbnavtabindex").checked;
    var ml = document.getElementById("mlnavdefaulttab");
    if(!bIndx){
      // Checking.
      // "Index" always follows "Contents" but precedes all other entries.
      // If the "Contents" entry exists, insert after it, else prepend.
      var arr = ml.getElementsByAttribute('label', "Contents");
      var iIndex = ml.getIndexOfItem(arr[0]);
      if(iIndex > -1){
        ml.insertItemAt(iIndex + 1, "Index", 1);
      }else{
        ml.insertItemAt(1, "Index", 1);
      }
    }else{
      // Unchecking.
      var arr = ml.getElementsByAttribute('label', "Index");
      var iIndex = ml.getIndexOfItem(arr[0]);
      // Deselect from list, if necessary.
      if(iIndex == ml.selectedIndex){
        ml.selectedIndex = -1;
        document.getElementById("navdefaulttab").value = -1;
      }
      ml.removeItemAt(ml.getIndexOfItem(arr[0]));
    }
  }

  function onClickFavs()
  {
    // checked returns the current state of the checkbox BEFORE the click changes it.
    var bFavs = document.getElementById("cbnavtabfavs").checked;
    var ml = document.getElementById("mlnavdefaulttab");

    if(!bFavs){
      // Checking.
      // "Favorites" always precedes "Search" but follows all other entries.
      // If the "Search" entry exists, insert before it, else append.
      var arr = ml.getElementsByAttribute('label', "Search");
      var iIndex = ml.getIndexOfItem(arr[0]);
      if(iIndex > -1){
        ml.insertItemAt(iIndex, "Favorites", 3);
      }else{
        ml.appendItem("Favorites", 3);
      }
    }else{
      // Unchecking.
      var arr = ml.getElementsByAttribute('label', "Favorites");
      var iIndex = ml.getIndexOfItem(arr[0]);
      // Deselect from list, if necessary.
      if(iIndex == ml.selectedIndex){
        ml.selectedIndex = -1;
        document.getElementById("navdefaulttab").value = -1;
      }
      ml.removeItemAt(ml.getIndexOfItem(arr[0]));
    }
  }

  function onClickSearch()
  {
    // checked returns the current state of the checkbox BEFORE the click changes it.
    var bSrch = document.getElementById("cbnavtabsearch").checked;
    var ml = document.getElementById("mlnavdefaulttab");

    if(!bSrch){
      // Checking.
      // Contents always appears last.
      ml.appendItem("Search", 2);
    }else{
      // Unchecking.
      var arr = ml.getElementsByAttribute('label', "Search");
      var iIndex = ml.getIndexOfItem(arr[0]);
      // Deselect from list, if necessary.
      if(iIndex == ml.selectedIndex){
        ml.selectedIndex = -1;
        document.getElementById("navdefaulttab").value = -1;
      }
      ml.removeItemAt(ml.getIndexOfItem(arr[0]));
    }
    document.getElementById("cbnavtabadvanced").disabled = bSrch;
  }
  
  function onClickHelpNoCompile()
  {
    // The "no compile" and "delete project files" options are
    // mutually exclusive.
    if(!document.getElementById("cbhelpnocompile").checked){
      document.getElementById("cbhelpdelproj").checked = false;
      // Update pref.
      document.getElementById("helpdelprojpref").value = false;
    }
  }
  
  function onClickHelpDelProj()
  {
    // The "no compile" and "delete project files" options are
    // mutually exclusive.
    if(!document.getElementById("cbhelpdelproj").checked){
      document.getElementById("cbhelpnocompile").checked = false;
      // Update pref.
      document.getElementById("helpnocompilepref").value = false;
    }
  }

  function setControls(bDisabled)
  {
    // Nav pane.
    document.getElementById("cbnavpaneclosed").disabled = bDisabled;
    if(bDisabled){
      // All controls disabled.
      document.getElementById("cbnavautosync").disabled = bDisabled;
    }else{
      // Enabled depending on TOC checkbox status.
      document.getElementById("cbnavautosync").disabled = !document.getElementById("cbnavtabtoc").checked;
    }
    document.getElementById("cbnavautoshowhide").disabled = bDisabled;
    document.getElementById("mlnavdefaulttab").disabled = bDisabled;
    document.getElementById("cbnavtabtoc").disabled = bDisabled;
    document.getElementById("cbnavtabindex").disabled = bDisabled;
    document.getElementById("cbnavtabsearch").disabled = bDisabled;
    document.getElementById("rgnavtabposition").disabled = bDisabled;
    if(bDisabled){
      // All controls disabled.
      document.getElementById("cbnavtabadvanced").disabled = bDisabled;
    }else{
      // Enabled depending on Search checkbox status.
      document.getElementById("cbnavtabadvanced").disabled = !document.getElementById("cbnavtabsearch").checked;
    }
    document.getElementById("cbnavtabfavs").disabled = bDisabled;
    // Buttons
    document.getElementById("cbhideshow").disabled = bDisabled;
    document.getElementById("cbback").disabled = bDisabled;
    document.getElementById("cbforward").disabled = bDisabled;
    document.getElementById("cbstop").disabled = bDisabled;
    document.getElementById("cbrefresh").disabled = bDisabled;
    document.getElementById("cbhome").disabled = bDisabled;
    if(bDisabled){
      // All controls disabled.
      document.getElementById("cblocate").disabled = bDisabled;
    }else{
      // Enabled depending on TOC checkbox status.
      document.getElementById("cblocate").disabled = !document.getElementById("cbnavtabtoc").checked;
    }
    document.getElementById("cboptions").disabled = bDisabled;
    document.getElementById("cbprint").disabled = bDisabled;
    document.getElementById("cbfont").disabled = bDisabled;
    document.getElementById("cbnext").disabled = bDisabled;
    document.getElementById("cbprevious").disabled = bDisabled;

  }
  
  function onClickHelp()
  {
    // Add tab, then make active
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var mainWindow = wm.getMostRecentWindow("navigator:browser");
    mainWindow.gBrowser.selectedTab = mainWindow.gBrowser.addTab("chrome://sbchm/locale/sbchm.html");

    this.close();
  }
  
  function onDialogAccept()
  {
    // Check paths are valid.
    var pathHhc = document.getElementById("hhcpathpref");
    var pathOutput = document.getElementById("outputpathpref");
    var pathLog = document.getElementById("logpathpref");
    var ret = true;

    if(pathHhc.value == ""){
      var errorHhcEmpty = this.strings.GetStringFromName("errorHhcEmpty");
      alert(errorHhcEmpty);
      ret = false;
    }
    else{
      var fileHhc = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
      fileHhc.initWithPath(pathHhc.value);
      if(!fileHhc.exists()){
        var errorHhcInvalid = this.strings.GetStringFromName("errorHhcInvalid");
        alert(pathHhc.value + "\n\n" + errorHhcInvalid);
        ret = false;
      }
    }
    if(pathOutput.value == ""){
      var errorPathEmpty = this.strings.GetStringFromName("errorPathEmpty");
      alert(errorPathEmpty);
      ret = false;
    }
    else{
      var fileOutput = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
      fileOutput.initWithPath(pathOutput.value);
      if(!fileOutput.exists()){
        var errorPathInvalid = this.strings.GetStringFromName("errorPathInvalid");
        alert(pathOutput.value + "\n\n" + errorPathInvalid);
        ret = false;
      }
    }
    // Log path is handled differently. Empty field is valid.
    if(pathLog.value != ""){
      // Find last path separator and get path component.
      var path = pathLog.value.toString();
      path = path.replace(/\\/g, "/");
      var iSep = path.lastIndexOf("/", path.length);
      if(iSep != -1){
         // It's not just a file name.
         path = pathLog.value.substr(0, iSep + 1);

        var fileLog = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
        fileLog.initWithPath(path);
        if(!fileLog.exists()){
          alert(path + "\n\n" + errorPath);
          ret = false;
        }
      }
    }
    return ret;
  }
  
  